#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main (int argc, char** argv)
  {
    int n;
    char filename[1024];


    if (argc != 2)
      {
        printf("Call by: genFn <int n>\n");
        exit(-1);
      }

    sscanf(argv[1], "%d", &n);

    if (n < 0)
      {
        printf("Parameter has to be >= 0\n");
        exit(-1);
      }


    int* x1 = new int[n+1];
    int* x2 = new int[n+1];
    int y1;
    int y2;


    int varnum = 1;

    sprintf(filename, "dqbfFn_%d.dqdimacs", n);

    FILE* filep = fopen(filename, "w");

    fprintf(filep, "p cnf %d %d\n", 2*n + 4, 4*n + 6); 

    for (int j=0; j < n+1; j++)
      x1[j] = varnum++; 
    for (int j=0; j < n+1; j++)
      x2[j] = varnum++; 
    y1 = varnum++; 
    y2 = varnum++; 

    fprintf(filep, "a "); 

    for (int j=0; j < n+1; j++)
      fprintf(filep, "%d ", x1[j]); 
    for (int j=0; j < n+1; j++)
      fprintf(filep, "%d ", x2[j]); 

    fprintf(filep, "0\n"); 

    fprintf(filep, "d %d ", y1); 
    for (int j=0; j < n+1; j++)
      fprintf(filep, "%d ", x1[j]); 
    fprintf(filep, "0\n"); 

    fprintf(filep, "d %d ", y2); 
    for (int j=0; j < n+1; j++)
      fprintf(filep, "%d ", x2[j]); 
    fprintf(filep, "0\n"); 

    for (int j=0; j < n+1; j++)
      {
        fprintf(filep, "%d %d ", y1, y2); 
        fprintf(filep, "%d 0\n", x1[j]); 
      }
   
    for (int j=0; j < n+1; j++)
      {
        fprintf(filep, "-%d -%d ", y1, y2); 
        fprintf(filep, "%d 0\n", x1[j]); 
      }

    for (int j=0; j < n+1; j++)
      {
        fprintf(filep, "%d %d ", y1, y2); 
        fprintf(filep, "%d 0\n", x2[j]); 
      }
   
    for (int j=0; j < n+1; j++)
      {
        fprintf(filep, "-%d -%d ", y1, y2); 
        fprintf(filep, "%d 0\n", x2[j]); 
      }


    fprintf(filep, "%d -%d ", y1, y2); 
    for (int j=0; j < n+1; j++)
      fprintf(filep, "-%d ", x1[j]); 
    for (int j=0; j < n+1; j++)
      fprintf(filep, "-%d ", x2[j]); 
    fprintf(filep, "0\n"); 

    fprintf(filep, "-%d %d ", y1, y2); 
    for (int j=0; j < n+1; j++)
      fprintf(filep, "-%d ", x1[j]); 
    for (int j=0; j < n+1; j++)
      fprintf(filep, "-%d ", x2[j]); 
    fprintf(filep, "0\n"); 

    delete [] x1;
    delete [] x2;

    fclose(filep);
  }
     
