#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main (int argc, char** argv)
  {
    int n;
    char filename[1024];


    if (argc != 2)
      {
        printf("Call by: genGn <int n>\n");
        exit(-1);
      }

    sscanf(argv[1], "%d", &n);

    if (n < 0)
      {
        printf("Parameter has to be >= 0\n");
        exit(-1);
      }


    int** x1 = new int*[n+1];
    int** x2 = new int*[n+1];
    int* y1 = new int[n+1];
    int* y2 = new int[n+1];


    for (int i=0; i < n+1; i++)
      x1[i] = new int[i+1]; 
    for (int i=0; i < n+1; i++)
      x2[i] = new int[i+1]; 

    int varnum = 1;

    sprintf(filename, "dqbfGn_%d.dqdimacs", n);

    FILE* filep = fopen(filename, "w");

    fprintf(filep, "p cnf %d %d\n", (n+4)*(n+1), 2*(n+1)*(n+3)); 

    for (int i=0; i < n+1; i++)
      {
        for (int j=0; j < i+1; j++)
          x1[i][j] = varnum++; 
        for (int j=0; j < i+1; j++)
          x2[i][j] = varnum++; 
        y1[i] = varnum++; 
        y2[i] = varnum++; 
      }

    fprintf(filep, "a "); 

    for (int i=0; i < n+1; i++)
      {
        for (int j=0; j < i+1; j++)
          fprintf(filep, "%d ", x1[i][j]); 
        for (int j=0; j < i+1; j++)
          fprintf(filep, "%d ", x2[i][j]); 
      }

    fprintf(filep, "0\n"); 

    for (int i=0; i < n+1; i++)
      {
        fprintf(filep, "d %d ", y1[i]); 
        for (int j=0; j < i+1; j++)
          fprintf(filep, "%d ", x1[i][j]); 
        fprintf(filep, "0\n"); 

        fprintf(filep, "d %d ", y2[i]); 
        for (int j=0; j < i+1; j++)
          fprintf(filep, "%d ", x2[i][j]); 
        fprintf(filep, "0\n"); 
      }

    for (int i=0; i < n+1; i++)
      {
        for (int j=0; j < i+1; j++)
          {
            fprintf(filep, "%d %d ", y1[i], y2[i]); 
            fprintf(filep, "%d 0\n", x1[i][j]); 
          }
       
        for (int j=0; j < i+1; j++)
          {
            fprintf(filep, "-%d -%d ", y1[i], y2[i]); 
            fprintf(filep, "%d 0\n", x1[i][j]); 
          }

        for (int j=0; j < i+1; j++)
          {
            fprintf(filep, "%d %d ", y1[i], y2[i]); 
            fprintf(filep, "%d 0\n", x2[i][j]); 
          }
       
        for (int j=0; j < i+1; j++)
          {
            fprintf(filep, "-%d -%d ", y1[i], y2[i]); 
            fprintf(filep, "%d 0\n", x2[i][j]); 
          }


        fprintf(filep, "%d -%d ", y1[i], y2[i]); 
        for (int j=0; j < i+1; j++)
          fprintf(filep, "-%d ", x1[i][j]); 
        for (int j=0; j < i+1; j++)
          fprintf(filep, "-%d ", x2[i][j]); 
        fprintf(filep, "0\n"); 

        fprintf(filep, "-%d %d ", y1[i], y2[i]); 
        for (int j=0; j < i+1; j++)
          fprintf(filep, "-%d ", x1[i][j]); 
        for (int j=0; j < i+1; j++)
          fprintf(filep, "-%d ", x2[i][j]); 
        fprintf(filep, "0\n"); 
      }

    for (int i=0; i < n+1; i++)
      delete [] x1[i];
    for (int i=0; i < n+1; i++)
      delete [] x2[i];

    delete [] x1;
    delete [] x2;
    delete [] y1;
    delete [] y2;

    fclose(filep);
  }
     
